// DO NOT EDIT
// Generated by JFlex 1.9.1 http://jflex.de/
// source: jflex/HeaderEurLex.jflex

/*******************************************************************************
 * Copyright (c) 2022-2029 Institute of Legal Information and Judicial Systems (IGSG-CNR)
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License. 
 * You may obtain a copy of the License at
 * 
 * http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and 
 * limitations under the License.
 *  
 * Authors: Lorenzo Bacci (IGSG-CNR)
 ******************************************************************************/
package it.cnr.igsg.marker;


@SuppressWarnings("fallthrough")
public class HeaderEurLex extends JFlexAnnotationService {

  /** This character denotes the end of file. */
  public static final int YYEOF = -1;

  /** Initial size of the lookahead buffer. */
  private static final int ZZ_BUFFERSIZE = 16384;

  // Lexical states.
  public static final int YYINITIAL = 0;
  public static final int inDocType = 2;
  public static final int inDate = 4;
  public static final int inTitle = 6;
  public static final int inPreamble = 8;

  /**
   * ZZ_LEXSTATE[l] is the state in the DFA for the lexical state l
   * ZZ_LEXSTATE[l+1] is the state in the DFA for the lexical state l
   *                  at the beginning of a line
   * l is of the form l = 2*k, k a non negative integer
   */
  private static final int ZZ_LEXSTATE[] = {
     0,  0,  1,  1,  2,  2,  3,  3,  4, 4
  };

  /**
   * Top-level table for translating characters to character classes
   */
  private static final int [] ZZ_CMAP_TOP = zzUnpackcmap_top();

  private static final String ZZ_CMAP_TOP_PACKED_0 =
    "\1\0\1\u0100\36\u0200\1\u0300\u10df\u0200";

  private static int [] zzUnpackcmap_top() {
    int [] result = new int[4352];
    int offset = 0;
    offset = zzUnpackcmap_top(ZZ_CMAP_TOP_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackcmap_top(String packed, int offset, int [] result) {
    int i = 0;       /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int count = packed.charAt(i++);
      int value = packed.charAt(i++);
      do result[j++] = value; while (--count > 0);
    }
    return j;
  }


  /**
   * Second-level tables for translating characters to character classes
   */
  private static final int [] ZZ_CMAP_BLOCKS = zzUnpackcmap_blocks();

  private static final String ZZ_CMAP_BLOCKS_PACKED_0 =
    "\11\0\1\1\1\2\1\0\1\1\1\3\22\0\1\1"+
    "\5\0\1\4\1\5\1\6\1\7\4\0\1\10\1\11"+
    "\1\12\1\13\1\14\1\15\2\16\2\17\1\20\1\21"+
    "\1\22\1\23\1\24\1\0\1\25\2\0\1\26\1\27"+
    "\1\30\1\31\1\32\1\33\1\34\1\35\1\36\2\0"+
    "\1\37\1\40\1\41\1\42\1\43\1\0\1\44\1\45"+
    "\1\46\1\47\1\50\3\0\1\51\1\0\1\52\1\0"+
    "\1\53\1\0\1\5\1\26\1\27\1\30\1\31\1\32"+
    "\1\33\1\34\1\35\1\36\2\0\1\37\1\40\1\41"+
    "\1\54\1\43\1\0\1\44\1\45\1\46\1\47\1\50"+
    "\3\0\1\51\65\0\1\53\3\0\1\5\5\0\1\53"+
    "\165\0\2\36\115\0\1\45\u0182\0\1\1\26\0\1\5"+
    "\346\0";

  private static int [] zzUnpackcmap_blocks() {
    int [] result = new int[1024];
    int offset = 0;
    offset = zzUnpackcmap_blocks(ZZ_CMAP_BLOCKS_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackcmap_blocks(String packed, int offset, int [] result) {
    int i = 0;       /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int count = packed.charAt(i++);
      int value = packed.charAt(i++);
      do result[j++] = value; while (--count > 0);
    }
    return j;
  }

  /**
   * Translates DFA states to action switch labels.
   */
  private static final int [] ZZ_ACTION = zzUnpackAction();

  private static final String ZZ_ACTION_PACKED_0 =
    "\5\0\1\1\2\2\1\1\24\3\3\1\162\0\1\4"+
    "\37\0\1\5\3\0\1\6\5\0\2\7\1\10\21\0"+
    "\4\11\2\0\1\12\3\0\1\13\17\0\1\14\62\0"+
    "\1\15\53\0\1\15\2\0\1\15\3\0\1\15\1\4"+
    "\5\0\1\15\67\0\1\16";

  private static int [] zzUnpackAction() {
    int [] result = new int[400];
    int offset = 0;
    offset = zzUnpackAction(ZZ_ACTION_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackAction(String packed, int offset, int [] result) {
    int i = 0;       /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int count = packed.charAt(i++);
      int value = packed.charAt(i++);
      do result[j++] = value; while (--count > 0);
    }
    return j;
  }


  /**
   * Translates a state to a row index in the transition table
   */
  private static final int [] ZZ_ROWMAP = zzUnpackRowMap();

  private static final String ZZ_ROWMAP_PACKED_0 =
    "\0\0\0\55\0\132\0\207\0\264\0\341\0\341\0\u010e"+
    "\0\u013b\0\341\0\u0168\0\u0195\0\u01c2\0\u01ef\0\u021c\0\u0249"+
    "\0\u0276\0\u02a3\0\u02d0\0\u02fd\0\u032a\0\u0357\0\u0384\0\u03b1"+
    "\0\u03de\0\u040b\0\u0438\0\u0465\0\u0492\0\u0357\0\u0384\0\u04bf"+
    "\0\u04ec\0\u0519\0\u0168\0\u0546\0\u0573\0\u05a0\0\u05cd\0\u05fa"+
    "\0\u0627\0\u0654\0\u0681\0\u06ae\0\u06db\0\u0708\0\u0735\0\u0762"+
    "\0\u078f\0\u0357\0\u0384\0\u07bc\0\u07e9\0\u0465\0\u0816\0\u0843"+
    "\0\u0870\0\u089d\0\u08ca\0\u08f7\0\u0924\0\u0951\0\u097e\0\u09ab"+
    "\0\u09d8\0\u0a05\0\u0a32\0\u0a5f\0\u0a8c\0\u0ab9\0\u0ae6\0\u0b13"+
    "\0\u0b40\0\u0b6d\0\u0b9a\0\u0bc7\0\u0bf4\0\u0c21\0\u0c4e\0\u0c7b"+
    "\0\u0ca8\0\u0cd5\0\u0d02\0\u0d2f\0\u0d5c\0\u0d89\0\u0db6\0\u0de3"+
    "\0\u0e10\0\u0e3d\0\u0e6a\0\u0e97\0\u0ec4\0\u0ef1\0\u0f1e\0\u0f4b"+
    "\0\u0f78\0\u0fa5\0\u0fd2\0\u0fff\0\u102c\0\u1059\0\u1086\0\u10b3"+
    "\0\u10e0\0\u110d\0\u113a\0\u1167\0\u1194\0\u11c1\0\u11ee\0\u121b"+
    "\0\u1248\0\u1275\0\u12a2\0\u12cf\0\u12fc\0\u1329\0\u1356\0\u1383"+
    "\0\u13b0\0\u13dd\0\u140a\0\u1437\0\u1464\0\u1491\0\u14be\0\u14eb"+
    "\0\u1518\0\u1545\0\u1572\0\u159f\0\u15cc\0\u15f9\0\u1626\0\u1653"+
    "\0\u1680\0\u16ad\0\u16da\0\u1707\0\u1734\0\u1761\0\u178e\0\u17bb"+
    "\0\u17e8\0\u1815\0\341\0\u1842\0\u186f\0\u189c\0\u18c9\0\u18f6"+
    "\0\u1923\0\u1950\0\u197d\0\u19aa\0\u19d7\0\u1a04\0\u1a31\0\u1a5e"+
    "\0\u1a8b\0\u1ab8\0\u1ae5\0\u1b12\0\u1b3f\0\u1b6c\0\u1b99\0\u1bc6"+
    "\0\u1bf3\0\u1c20\0\u1c4d\0\u1c7a\0\u1ca7\0\u1cd4\0\u1d01\0\u1d2e"+
    "\0\u1d5b\0\u1d88\0\u1db5\0\u1de2\0\u1e0f\0\u1e3c\0\u1db5\0\u1e69"+
    "\0\u1e96\0\u1ec3\0\u1ef0\0\u1f1d\0\341\0\u178e\0\341\0\u1f4a"+
    "\0\u1f77\0\u1fa4\0\u1fd1\0\u1ffe\0\u202b\0\u2058\0\u2085\0\u20b2"+
    "\0\u20df\0\u210c\0\u2139\0\u2166\0\u2193\0\u1db5\0\u21c0\0\u21ed"+
    "\0\341\0\u221a\0\u1ae5\0\u2247\0\u2274\0\u22a1\0\341\0\u22ce"+
    "\0\u22fb\0\u2328\0\341\0\u2355\0\u2382\0\u23af\0\u23dc\0\u2409"+
    "\0\u2436\0\u2463\0\u2490\0\u24bd\0\u24ea\0\u2517\0\u2544\0\u2571"+
    "\0\u259e\0\u25cb\0\u25f8\0\u2625\0\u2652\0\u267f\0\u26ac\0\u26d9"+
    "\0\u2706\0\u2733\0\u2760\0\u278d\0\u27ba\0\u27e7\0\u2814\0\u2841"+
    "\0\u286e\0\u289b\0\u28c8\0\u28f5\0\u2922\0\u294f\0\u297c\0\u29a9"+
    "\0\u29d6\0\u2a03\0\u25f8\0\u2a30\0\u021c\0\u0249\0\u2a5d\0\u2a8a"+
    "\0\u02fd\0\u2ab7\0\u2ae4\0\u2b11\0\u2b3e\0\u2b6b\0\u2b98\0\u2bc5"+
    "\0\u2bf2\0\u2c1f\0\u2c4c\0\u2c79\0\u2ca6\0\u2cd3\0\u2d00\0\u2d2d"+
    "\0\u2d5a\0\u2d87\0\u2db4\0\u2de1\0\u2e0e\0\u2e3b\0\u2e68\0\u2e95"+
    "\0\u2ec2\0\u2eef\0\u02a3\0\u2f1c\0\u2f49\0\u2f76\0\u2fa3\0\u2fd0"+
    "\0\u2ffd\0\u302a\0\u3057\0\u3084\0\u30b1\0\u30de\0\u310b\0\u3138"+
    "\0\u3165\0\u3192\0\u31bf\0\u2e3b\0\u31ec\0\u3219\0\u3246\0\u3273"+
    "\0\u32a0\0\u32cd\0\u32fa\0\u3327\0\u3354\0\u3381\0\u33ae\0\u33db"+
    "\0\u3408\0\u3435\0\u3462\0\u348f\0\u34bc\0\u34e9\0\u3516\0\u3543"+
    "\0\u3570\0\u359d\0\u35ca\0\u35f7\0\u3624\0\u3651\0\u367e\0\u36ab"+
    "\0\u36d8\0\u3705\0\u3732\0\u375f\0\u378c\0\u37b9\0\u37e6\0\341"+
    "\0\u3813\0\u3840\0\u386d\0\u389a\0\u38c7\0\u38f4\0\u36d8\0\u3921"+
    "\0\u394e\0\u397b\0\u39a8\0\u39d5\0\u3a02\0\u3a2f\0\u3a5c\0\u3a89"+
    "\0\u3ab6\0\u3ae3\0\u3b10\0\u3b3d\0\u3b6a\0\u3b97\0\u3bc4\0\u3bf1"+
    "\0\u3c1e\0\u3c4b\0\u3c78\0\u3ca5\0\u3cd2\0\u3cff\0\u3d2c\0\u3d59"+
    "\0\u3d86\0\u3db3\0\u3de0\0\u3e0d\0\u3e3a\0\u3e67\0\u3e94\0\u3ec1"+
    "\0\u3eee\0\u3f1b\0\u3f48\0\u3f75\0\u3fa2\0\u3fcf\0\u3ffc\0\u4029"+
    "\0\u4056\0\u4083\0\u40b0\0\u40dd\0\u410a\0\u4137\0\u4164\0\341";

  private static int [] zzUnpackRowMap() {
    int [] result = new int[400];
    int offset = 0;
    offset = zzUnpackRowMap(ZZ_ROWMAP_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackRowMap(String packed, int offset, int [] result) {
    int i = 0;  /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length() - 1;
    while (i < l) {
      int high = packed.charAt(i++) << 16;
      result[j++] = high | packed.charAt(i++);
    }
    return j;
  }

  /**
   * The transition table of the DFA
   */
  private static final int [] ZZ_TRANS = zzUnpacktrans();

  private static final String ZZ_TRANS_PACKED_0 =
    "\2\6\1\7\1\10\20\6\1\11\30\6\12\12\1\13"+
    "\1\14\1\15\5\13\2\12\1\16\2\12\1\17\1\20"+
    "\1\21\1\22\3\12\1\23\4\12\1\24\1\25\11\12"+
    "\3\26\1\27\5\12\1\30\1\31\1\32\1\33\4\34"+
    "\2\12\1\35\30\12\1\6\3\36\1\37\17\6\1\40"+
    "\105\6\57\0\1\7\107\0\1\41\30\0\1\42\10\43"+
    "\30\0\1\42\13\0\1\42\6\43\1\44\1\45\30\0"+
    "\1\42\13\0\1\42\1\46\7\43\30\0\1\42\13\0"+
    "\1\47\23\0\1\50\45\0\1\51\70\0\1\52\11\0"+
    "\1\52\32\0\1\53\3\0\1\54\65\0\1\55\46\0"+
    "\1\56\41\0\1\57\60\0\1\60\3\0\1\61\17\0"+
    "\3\62\1\63\17\0\1\64\71\0\1\65\26\0\7\66"+
    "\34\0\1\66\2\0\1\67\5\0\10\66\4\0\1\70"+
    "\2\0\1\71\1\0\1\72\1\73\2\0\1\74\1\75"+
    "\1\76\1\77\2\0\1\100\5\0\1\66\1\101\1\0"+
    "\1\66\2\0\1\67\5\0\10\66\4\0\1\70\2\0"+
    "\1\71\1\0\1\72\1\73\2\0\1\74\1\75\1\76"+
    "\1\77\2\0\1\100\6\0\1\77\1\0\1\66\2\0"+
    "\1\67\5\0\2\66\12\0\1\70\2\0\1\71\1\0"+
    "\1\72\1\73\2\0\1\74\1\75\1\76\1\77\2\0"+
    "\1\100\6\0\1\77\1\0\1\66\2\0\1\67\21\0"+
    "\1\70\2\0\1\71\1\0\1\72\1\73\2\0\1\74"+
    "\1\75\1\76\1\77\2\0\1\100\6\0\1\77\11\0"+
    "\1\102\23\0\1\103\30\0\1\104\23\0\1\105\41\0"+
    "\1\106\45\0\1\107\1\110\51\0\1\42\5\43\3\111"+
    "\30\0\1\42\13\0\1\42\10\111\30\0\1\42\13\0"+
    "\1\42\3\111\5\43\30\0\1\42\37\0\1\112\41\0"+
    "\1\113\73\0\1\114\53\0\1\115\1\116\43\0\1\117"+
    "\70\0\1\120\54\0\1\121\41\0\1\122\67\0\1\123"+
    "\44\0\1\124\65\0\1\125\44\0\1\126\46\0\1\127"+
    "\66\0\1\130\47\0\1\131\6\0\1\132\47\0\1\133"+
    "\50\0\1\134\54\0\1\135\3\0\1\136\65\0\1\137"+
    "\33\0\1\140\70\0\1\141\11\0\1\141\46\0\1\142"+
    "\40\0\1\143\23\0\1\66\2\0\1\67\21\0\1\70"+
    "\2\0\1\71\1\0\1\72\1\73\2\0\1\74\1\75"+
    "\1\76\1\77\2\0\1\100\1\142\5\0\1\77\35\0"+
    "\1\144\41\0\1\145\67\0\1\146\41\0\1\147\75\0"+
    "\1\150\31\0\1\151\1\152\45\0\1\153\53\0\1\42"+
    "\10\154\30\0\1\42\24\0\1\155\75\0\1\156\41\0"+
    "\1\157\64\0\1\160\61\0\1\161\45\0\1\162\50\0"+
    "\1\163\64\0\1\164\11\0\1\164\36\0\1\165\55\0"+
    "\1\166\57\0\1\167\11\0\1\167\42\0\1\170\11\0"+
    "\1\170\22\0\1\171\77\0\1\172\36\0\1\173\67\0"+
    "\1\174\11\0\1\174\44\0\1\175\40\0\1\176\53\0"+
    "\1\177\66\0\1\200\62\0\1\201\41\0\1\202\54\0"+
    "\1\203\7\0\1\204\60\0\1\176\52\0\1\205\54\0"+
    "\1\206\30\0\1\207\75\0\1\210\33\0\1\211\75\0"+
    "\1\212\12\0\1\213\2\0\1\214\20\0\1\215\46\0"+
    "\3\216\45\0\10\216\45\0\3\216\51\0\1\217\10\43"+
    "\30\0\1\217\45\0\1\220\12\0\1\221\2\0\1\222"+
    "\20\0\1\223\55\0\1\224\64\0\1\225\54\0\1\226"+
    "\63\0\1\227\55\0\1\230\51\0\1\231\55\0\1\232"+
    "\36\0\1\233\65\0\1\234\54\0\1\235\60\0\1\236"+
    "\54\0\1\237\56\0\1\240\10\0\1\241\2\0\1\242"+
    "\1\243\2\0\1\241\1\0\1\244\1\245\1\246\5\244"+
    "\23\0\1\247\10\0\1\241\2\0\1\242\1\243\2\0"+
    "\1\241\1\0\1\244\1\245\1\246\5\244\14\0\1\250"+
    "\17\0\1\241\2\0\1\242\1\243\2\0\1\241\1\0"+
    "\1\244\1\245\1\246\5\244\10\0\1\251\23\0\1\241"+
    "\2\0\1\242\1\243\2\0\1\241\1\0\1\244\1\245"+
    "\1\246\5\244\5\0\1\252\26\0\1\241\2\0\1\242"+
    "\1\243\2\0\1\241\1\0\1\244\1\245\1\246\5\244"+
    "\17\0\1\253\14\0\1\241\2\0\1\242\1\243\2\0"+
    "\1\241\1\0\1\244\1\245\1\246\5\244\12\0\1\254"+
    "\21\0\1\241\2\0\1\242\1\243\2\0\1\241\1\0"+
    "\1\244\1\245\1\246\5\244\15\0\1\255\16\0\1\241"+
    "\2\0\1\242\1\243\2\0\1\241\1\0\1\244\1\245"+
    "\1\246\5\244\12\0\1\255\21\0\1\241\2\0\1\242"+
    "\1\243\2\0\1\241\1\0\1\244\1\245\1\246\5\244"+
    "\27\0\1\256\4\0\1\241\2\0\1\242\1\243\2\0"+
    "\1\241\1\0\1\244\1\245\1\246\5\244\20\0\1\257"+
    "\11\0\1\257\1\0\1\241\2\0\1\242\1\243\2\0"+
    "\1\241\1\0\1\244\1\245\1\246\5\244\24\0\1\176"+
    "\51\0\1\260\12\0\1\261\2\0\1\262\20\0\1\263"+
    "\72\0\1\264\12\0\1\265\2\0\1\266\20\0\1\267"+
    "\27\0\25\213\1\215\27\213\41\0\1\270\14\0\1\215"+
    "\2\0\1\271\24\0\1\272\4\0\1\273\5\0\1\274"+
    "\22\0\10\275\45\0\10\276\60\0\1\277\27\0\25\221"+
    "\1\223\27\221\41\0\1\300\14\0\1\224\2\0\1\301"+
    "\23\0\1\302\71\0\1\303\43\0\1\304\56\0\1\305"+
    "\64\0\1\306\40\0\1\307\60\0\1\310\56\0\1\311"+
    "\42\0\1\312\75\0\1\313\6\0\1\314\2\0\1\315"+
    "\20\0\1\316\52\0\1\62\74\0\1\317\12\0\1\241"+
    "\2\0\1\242\1\243\4\0\1\244\1\245\1\246\5\244"+
    "\74\0\1\320\25\0\10\244\45\0\10\321\45\0\6\321"+
    "\1\322\1\323\45\0\1\324\7\321\101\0\1\256\45\0"+
    "\1\325\55\0\1\257\60\0\1\253\36\0\1\255\67\0"+
    "\1\256\51\0\1\256\60\0\1\241\11\0\1\241\27\0"+
    "\1\326\52\0\1\327\27\0\25\261\1\263\27\261\41\0"+
    "\1\330\14\0\3\316\1\331\17\0\1\332\55\0\1\333"+
    "\27\0\25\265\1\267\27\265\41\0\1\334\42\0\1\335"+
    "\66\0\1\336\45\0\1\337\3\0\1\340\57\0\1\341"+
    "\45\0\1\342\3\0\1\343\45\0\1\344\66\0\1\345"+
    "\45\0\1\346\67\0\1\347\46\0\1\350\57\0\1\351"+
    "\11\0\1\351\36\0\1\352\44\0\1\353\13\0\1\353"+
    "\11\0\1\353\51\0\1\354\35\0\1\355\62\0\1\356"+
    "\65\0\1\227\3\0\25\314\1\316\27\314\41\0\1\357"+
    "\36\0\1\66\60\0\1\360\44\0\3\244\45\0\3\244"+
    "\72\0\1\241\66\0\1\325\37\0\1\361\66\0\1\362"+
    "\24\0\1\363\72\0\1\364\72\0\1\365\36\0\1\366"+
    "\55\0\1\367\70\0\1\370\41\0\1\371\57\0\1\372"+
    "\65\0\1\373\54\0\1\374\36\0\1\375\66\0\1\376"+
    "\51\0\1\377\54\0\1\u0100\57\0\1\u0101\63\0\1\u0102"+
    "\5\0\1\u0103\2\0\1\u0104\22\0\1\u0105\1\u0106\1\u0107"+
    "\1\u0108\10\0\1\u0109\62\0\1\u010a\44\0\1\u010b\45\0"+
    "\1\u010c\51\0\1\u010d\72\0\1\u010e\54\0\1\u010f\36\0"+
    "\1\u0110\62\0\1\u0111\64\0\1\u0112\52\0\1\u0113\56\0"+
    "\1\u0114\45\0\1\u0115\50\0\1\u0116\60\0\1\u0117\60\0"+
    "\1\u0118\11\0\1\u0118\42\0\1\u0119\11\0\1\u0119\43\0"+
    "\1\u011a\56\0\1\u011b\55\0\1\u011c\50\0\1\u011d\11\0"+
    "\1\u011d\42\0\1\353\11\0\1\353\32\0\1\u011e\50\0"+
    "\1\u011e\67\0\1\u011f\45\0\1\u0120\23\0\1\u0121\2\0"+
    "\1\u0122\22\0\1\u0105\1\u0106\1\u0107\1\u0123\10\0\1\u0109"+
    "\3\0\1\55\47\0\1\u011e\11\0\1\u011e\46\0\1\u0100"+
    "\47\0\1\u0124\60\0\1\u0125\52\0\1\u0126\54\0\1\u0127"+
    "\56\0\1\u0128\31\0\1\u0129\75\0\1\u012a\34\0\1\213"+
    "\74\0\1\u012b\56\0\1\u012c\55\0\1\u012d\52\0\1\u012e"+
    "\47\0\1\u012f\54\0\1\u0130\40\0\1\221\74\0\1\u0131"+
    "\55\0\1\u0132\51\0\1\u0133\14\0\1\u0134\2\0\1\u0135"+
    "\1\0\1\u0136\20\0\1\u0137\1\u0138\1\0\1\u0139\10\0"+
    "\1\u013a\3\0\1\u013b\34\0\1\u013c\64\0\1\u013d\16\0"+
    "\1\u0121\2\0\1\u0122\22\0\1\u0105\1\u0106\1\u0107\1\u0123"+
    "\10\0\1\u0109\52\0\1\u013e\61\0\1\u013f\51\0\1\u0140"+
    "\34\0\1\241\54\0\1\261\74\0\1\u0141\54\0\1\u0142"+
    "\34\0\1\265\54\0\1\215\67\0\1\u0143\64\0\1\u0144"+
    "\44\0\1\u0145\44\0\1\u0146\75\0\1\u0147\30\0\1\224"+
    "\57\0\1\u0148\60\0\1\353\63\0\1\u0149\42\0\1\u0137"+
    "\1\u0138\1\0\1\u0139\10\0\1\u013a\3\0\1\u013b\35\0"+
    "\1\u013b\56\0\1\u014a\71\0\1\u014b\37\0\1\u014c\54\0"+
    "\1\u014d\67\0\1\u014e\10\0\1\u013d\2\0\1\u014f\22\0"+
    "\1\u0105\1\u0106\1\0\1\u0123\10\0\1\u0109\40\0\1\u0150"+
    "\67\0\1\u0151\11\0\1\u0151\23\0\1\314\54\0\1\316"+
    "\56\0\1\u0152\71\0\1\u0153\11\0\1\u0153\36\0\1\u0154"+
    "\67\0\1\u0155\43\0\1\u0156\65\0\1\u012c\42\0\1\u0133"+
    "\44\0\1\u0157\34\0\1\u0158\20\0\1\u0159\1\0\1\u014d"+
    "\66\0\1\u015a\55\0\1\u015b\16\0\1\u0158\110\0\1\u015c"+
    "\52\0\1\u015d\60\0\1\u015e\10\0\1\u015f\2\0\1\u0160"+
    "\1\0\1\u0136\20\0\1\u0137\1\u0138\1\u0161\1\u0162\10\0"+
    "\1\u013a\3\0\1\u013b\6\0\3\u0152\1\u0163\111\0\1\u0164"+
    "\63\0\1\u0165\55\0\1\u0166\35\0\1\u0167\67\0\1\u0168"+
    "\35\0\1\u014d\54\0\1\u0169\56\0\1\u014d\47\0\1\u0103"+
    "\60\0\1\u016a\70\0\1\u016b\52\0\1\u016c\51\0\1\u016d"+
    "\63\0\1\u016e\1\0\1\u014b\46\0\1\u016f\45\0\1\u0170"+
    "\50\0\1\u0170\70\0\1\u0170\11\0\1\u0170\41\0\1\u0171"+
    "\56\0\1\u0172\57\0\1\u0173\53\0\1\u0174\32\0\1\u0121"+
    "\60\0\1\u0175\26\0\1\u016d\2\0\1\u0176\25\0\1\u0177"+
    "\54\0\1\u0178\51\0\1\u0179\25\0\24\u017a\1\0\30\u017a"+
    "\46\0\1\u0166\31\0\1\u0134\73\0\1\u017b\11\0\1\u017b"+
    "\43\0\1\u017c\56\0\1\u017d\50\0\1\u017e\60\0\1\u017f"+
    "\37\0\1\u0180\71\0\1\u0181\7\0\24\u017a\1\u0182\30\u017a"+
    "\40\0\1\u014d\37\0\1\u013d\74\0\1\u0183\40\0\1\u0184"+
    "\57\0\1\u0185\71\0\1\u0186\50\0\1\u0187\22\0\1\u0188"+
    "\66\0\1\u015f\76\0\1\u0189\37\0\1\235\72\0\1\u018a"+
    "\31\0\1\u0152\66\0\1\u018b\62\0\1\u018c\47\0\1\u018d"+
    "\40\0\1\u018e\55\0\1\u016d\101\0\1\u010a\47\0\1\u018f"+
    "\36\0\1\u0190\27\0";

  private static int [] zzUnpacktrans() {
    int [] result = new int[16785];
    int offset = 0;
    offset = zzUnpacktrans(ZZ_TRANS_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpacktrans(String packed, int offset, int [] result) {
    int i = 0;       /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int count = packed.charAt(i++);
      int value = packed.charAt(i++);
      value--;
      do result[j++] = value; while (--count > 0);
    }
    return j;
  }


  /** Error code for "Unknown internal scanner error". */
  private static final int ZZ_UNKNOWN_ERROR = 0;
  /** Error code for "could not match input". */
  private static final int ZZ_NO_MATCH = 1;
  /** Error code for "pushback value was too large". */
  private static final int ZZ_PUSHBACK_2BIG = 2;

  /**
   * Error messages for {@link #ZZ_UNKNOWN_ERROR}, {@link #ZZ_NO_MATCH}, and
   * {@link #ZZ_PUSHBACK_2BIG} respectively.
   */
  private static final String ZZ_ERROR_MSG[] = {
    "Unknown internal scanner error",
    "Error: could not match input",
    "Error: pushback value was too large"
  };

  /**
   * ZZ_ATTRIBUTE[aState] contains the attributes of state {@code aState}
   */
  private static final int [] ZZ_ATTRIBUTE = zzUnpackAttribute();

  private static final String ZZ_ATTRIBUTE_PACKED_0 =
    "\5\0\2\11\2\1\1\11\26\1\162\0\1\11\37\0"+
    "\1\1\3\0\1\1\5\0\1\11\1\1\1\11\21\0"+
    "\1\11\3\1\2\0\1\11\3\0\1\11\17\0\1\1"+
    "\62\0\1\1\53\0\1\1\2\0\1\1\3\0\2\1"+
    "\5\0\1\11\67\0\1\11";

  private static int [] zzUnpackAttribute() {
    int [] result = new int[400];
    int offset = 0;
    offset = zzUnpackAttribute(ZZ_ATTRIBUTE_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackAttribute(String packed, int offset, int [] result) {
    int i = 0;       /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int count = packed.charAt(i++);
      int value = packed.charAt(i++);
      do result[j++] = value; while (--count > 0);
    }
    return j;
  }

  /** Input device. */
  private java.io.Reader zzReader;

  /** Current state of the DFA. */
  private int zzState;

  /** Current lexical state. */
  private int zzLexicalState = YYINITIAL;

  /**
   * This buffer contains the current text to be matched and is the source of the {@link #yytext()}
   * string.
   */
  private char zzBuffer[] = new char[Math.min(ZZ_BUFFERSIZE, zzMaxBufferLen())];

  /** Text position at the last accepting state. */
  private int zzMarkedPos;

  /** Current text position in the buffer. */
  private int zzCurrentPos;

  /** Marks the beginning of the {@link #yytext()} string in the buffer. */
  private int zzStartRead;

  /** Marks the last character in the buffer, that has been read from input. */
  private int zzEndRead;

  /**
   * Whether the scanner is at the end of file.
   * @see #yyatEOF
   */
  private boolean zzAtEOF;

  /**
   * The number of occupied positions in {@link #zzBuffer} beyond {@link #zzEndRead}.
   *
   * <p>When a lead/high surrogate has been read from the input stream into the final
   * {@link #zzBuffer} position, this will have a value of 1; otherwise, it will have a value of 0.
   */
  private int zzFinalHighSurrogate = 0;

  /** Number of newlines encountered up to the start of the matched text. */
  private int yyline;

  /** Number of characters from the last newline up to the start of the matched text. */
  private int yycolumn;

  /** Number of characters up to the start of the matched text. */
  private long yychar;

  /** Whether the scanner is currently at the beginning of a line. */
  @SuppressWarnings("unused")
  private boolean zzAtBOL = true;

  /** Whether the user-EOF-code has already been executed. */
  @SuppressWarnings("unused")
  private boolean zzEOFDone;

  /* user code: */
	
	HeaderEurLex() { }
	
	private int lineNumber = 0;
	
	private boolean headerFound = false;
	
	public boolean isHeaderFound() {
	
		return this.headerFound;
	}
	
	private StringBuilder extendTitle = new StringBuilder();
	


  /**
   * Creates a new scanner
   *
   * @param   in  the java.io.Reader to read input from.
   */
  public HeaderEurLex(java.io.Reader in) {
    this.zzReader = in;
  }


  /** Returns the maximum size of the scanner buffer, which limits the size of tokens. */
  private int zzMaxBufferLen() {
    return Integer.MAX_VALUE;
  }

  /**  Whether the scanner buffer can grow to accommodate a larger token. */
  private boolean zzCanGrow() {
    return true;
  }

  /**
   * Translates raw input code points to DFA table row
   */
  private static int zzCMap(int input) {
    int offset = input & 255;
    return offset == input ? ZZ_CMAP_BLOCKS[offset] : ZZ_CMAP_BLOCKS[ZZ_CMAP_TOP[input >> 8] | offset];
  }

  /**
   * Refills the input buffer.
   *
   * @return {@code false} iff there was new input.
   * @exception java.io.IOException  if any I/O-Error occurs
   */
  private boolean zzRefill() throws java.io.IOException {

    /* first: make room (if you can) */
    if (zzStartRead > 0) {
      zzEndRead += zzFinalHighSurrogate;
      zzFinalHighSurrogate = 0;
      System.arraycopy(zzBuffer, zzStartRead,
                       zzBuffer, 0,
                       zzEndRead - zzStartRead);

      /* translate stored positions */
      zzEndRead -= zzStartRead;
      zzCurrentPos -= zzStartRead;
      zzMarkedPos -= zzStartRead;
      zzStartRead = 0;
    }

    /* is the buffer big enough? */
    if (zzCurrentPos >= zzBuffer.length - zzFinalHighSurrogate && zzCanGrow()) {
      /* if not, and it can grow: blow it up */
      char newBuffer[] = new char[Math.min(zzBuffer.length * 2, zzMaxBufferLen())];
      System.arraycopy(zzBuffer, 0, newBuffer, 0, zzBuffer.length);
      zzBuffer = newBuffer;
      zzEndRead += zzFinalHighSurrogate;
      zzFinalHighSurrogate = 0;
    }

    /* fill the buffer with new input */
    int requested = zzBuffer.length - zzEndRead;
    int numRead = zzReader.read(zzBuffer, zzEndRead, requested);

    /* not supposed to occur according to specification of java.io.Reader */
    if (numRead == 0) {
      if (requested == 0) {
        throw new java.io.EOFException("Scan buffer limit reached ["+zzBuffer.length+"]");
      }
      else {
        throw new java.io.IOException(
            "Reader returned 0 characters. See JFlex examples/zero-reader for a workaround.");
      }
    }
    if (numRead > 0) {
      zzEndRead += numRead;
      if (Character.isHighSurrogate(zzBuffer[zzEndRead - 1])) {
        if (numRead == requested) { // We requested too few chars to encode a full Unicode character
          --zzEndRead;
          zzFinalHighSurrogate = 1;
        } else {                    // There is room in the buffer for at least one more char
          int c = zzReader.read();  // Expecting to read a paired low surrogate char
          if (c == -1) {
            return true;
          } else {
            zzBuffer[zzEndRead++] = (char)c;
          }
        }
      }
      /* potentially more input available */
      return false;
    }

    /* numRead < 0 ==> end of stream */
    return true;
  }


  /**
   * Closes the input reader.
   *
   * @throws java.io.IOException if the reader could not be closed.
   */
  public final void yyclose() throws java.io.IOException {
    zzAtEOF = true; // indicate end of file
    zzEndRead = zzStartRead; // invalidate buffer

    if (zzReader != null) {
      zzReader.close();
    }
  }


  /**
   * Resets the scanner to read from a new input stream.
   *
   * <p>Does not close the old reader.
   *
   * <p>All internal variables are reset, the old input stream <b>cannot</b> be reused (internal
   * buffer is discarded and lost). Lexical state is set to {@code ZZ_INITIAL}.
   *
   * <p>Internal scan buffer is resized down to its initial length, if it has grown.
   *
   * @param reader The new input stream.
   */
  public final void yyreset(java.io.Reader reader) {
    zzReader = reader;
    zzEOFDone = false;
    yyResetPosition();
    zzLexicalState = YYINITIAL;
    int initBufferSize = Math.min(ZZ_BUFFERSIZE, zzMaxBufferLen());
    if (zzBuffer.length > initBufferSize) {
      zzBuffer = new char[initBufferSize];
    }
  }

  /**
   * Resets the input position.
   */
  private final void yyResetPosition() {
      zzAtBOL  = true;
      zzAtEOF  = false;
      zzCurrentPos = 0;
      zzMarkedPos = 0;
      zzStartRead = 0;
      zzEndRead = 0;
      zzFinalHighSurrogate = 0;
      yyline = 0;
      yycolumn = 0;
      yychar = 0L;
  }


  /**
   * Returns whether the scanner has reached the end of the reader it reads from.
   *
   * @return whether the scanner has reached EOF.
   */
  public final boolean yyatEOF() {
    return zzAtEOF;
  }


  /**
   * Returns the current lexical state.
   *
   * @return the current lexical state.
   */
  public final int yystate() {
    return zzLexicalState;
  }


  /**
   * Enters a new lexical state.
   *
   * @param newState the new lexical state
   */
  public final void yybegin(int newState) {
    zzLexicalState = newState;
  }


  /**
   * Returns the text matched by the current regular expression.
   *
   * @return the matched text.
   */
  public final String yytext() {
    return new String(zzBuffer, zzStartRead, zzMarkedPos-zzStartRead);
  }


  /**
   * Returns the character at the given position from the matched text.
   *
   * <p>It is equivalent to {@code yytext().charAt(pos)}, but faster.
   *
   * @param position the position of the character to fetch. A value from 0 to {@code yylength()-1}.
   *
   * @return the character at {@code position}.
   */
  public final char yycharat(int position) {
    return zzBuffer[zzStartRead + position];
  }


  /**
   * How many characters were matched.
   *
   * @return the length of the matched text region.
   */
  public final int yylength() {
    return zzMarkedPos-zzStartRead;
  }


  /**
   * Reports an error that occurred while scanning.
   *
   * <p>In a well-formed scanner (no or only correct usage of {@code yypushback(int)} and a
   * match-all fallback rule) this method will only be called with things that
   * "Can't Possibly Happen".
   *
   * <p>If this method is called, something is seriously wrong (e.g. a JFlex bug producing a faulty
   * scanner etc.).
   *
   * <p>Usual syntax/scanner level error handling should be done in error fallback rules.
   *
   * @param errorCode the code of the error message to display.
   */
  private static void zzScanError(int errorCode) {
    String message;
    try {
      message = ZZ_ERROR_MSG[errorCode];
    } catch (ArrayIndexOutOfBoundsException e) {
      message = ZZ_ERROR_MSG[ZZ_UNKNOWN_ERROR];
    }

    throw new Error(message);
  }


  /**
   * Pushes the specified amount of characters back into the input stream.
   *
   * <p>They will be read again by then next call of the scanning method.
   *
   * @param number the number of characters to be read again. This number must not be greater than
   *     {@link #yylength()}.
   */
  public void yypushback(int number)  {
    if ( number > yylength() )
      zzScanError(ZZ_PUSHBACK_2BIG);

    zzMarkedPos -= number;
  }




  /**
   * Resumes scanning until the next regular expression is matched, the end of input is encountered
   * or an I/O-Error occurs.
   *
   * @return the next token.
   * @exception java.io.IOException if any I/O-Error occurs.
   */
  public int yylex() throws java.io.IOException
  {
    int zzInput;
    int zzAction;

    // cached fields:
    int zzCurrentPosL;
    int zzMarkedPosL;
    int zzEndReadL = zzEndRead;
    char[] zzBufferL = zzBuffer;

    int [] zzTransL = ZZ_TRANS;
    int [] zzRowMapL = ZZ_ROWMAP;
    int [] zzAttrL = ZZ_ATTRIBUTE;

    while (true) {
      zzMarkedPosL = zzMarkedPos;

      yychar+= zzMarkedPosL-zzStartRead;

      boolean zzR = false;
      int zzCh;
      int zzCharCount;
      for (zzCurrentPosL = zzStartRead  ;
           zzCurrentPosL < zzMarkedPosL ;
           zzCurrentPosL += zzCharCount ) {
        zzCh = Character.codePointAt(zzBufferL, zzCurrentPosL, zzMarkedPosL);
        zzCharCount = Character.charCount(zzCh);
        switch (zzCh) {
        case '\u000B':  // fall through
        case '\u000C':  // fall through
        case '\u0085':  // fall through
        case '\u2028':  // fall through
        case '\u2029':
          yyline++;
          yycolumn = 0;
          zzR = false;
          break;
        case '\r':
          yyline++;
          yycolumn = 0;
          zzR = true;
          break;
        case '\n':
          if (zzR)
            zzR = false;
          else {
            yyline++;
            yycolumn = 0;
          }
          break;
        default:
          zzR = false;
          yycolumn += zzCharCount;
        }
      }

      if (zzR) {
        // peek one character ahead if it is
        // (if we have counted one line too much)
        boolean zzPeek;
        if (zzMarkedPosL < zzEndReadL)
          zzPeek = zzBufferL[zzMarkedPosL] == '\n';
        else if (zzAtEOF)
          zzPeek = false;
        else {
          boolean eof = zzRefill();
          zzEndReadL = zzEndRead;
          zzMarkedPosL = zzMarkedPos;
          zzBufferL = zzBuffer;
          if (eof)
            zzPeek = false;
          else
            zzPeek = zzBufferL[zzMarkedPosL] == '\n';
        }
        if (zzPeek) yyline--;
      }
      zzAction = -1;

      zzCurrentPosL = zzCurrentPos = zzStartRead = zzMarkedPosL;

      zzState = ZZ_LEXSTATE[zzLexicalState];

      // set up zzAction for empty match case:
      int zzAttributes = zzAttrL[zzState];
      if ( (zzAttributes & 1) == 1 ) {
        zzAction = zzState;
      }


      zzForAction: {
        while (true) {

          if (zzCurrentPosL < zzEndReadL) {
            zzInput = Character.codePointAt(zzBufferL, zzCurrentPosL, zzEndReadL);
            zzCurrentPosL += Character.charCount(zzInput);
          }
          else if (zzAtEOF) {
            zzInput = YYEOF;
            break zzForAction;
          }
          else {
            // store back cached positions
            zzCurrentPos  = zzCurrentPosL;
            zzMarkedPos   = zzMarkedPosL;
            boolean eof = zzRefill();
            // get translated positions and possibly new buffer
            zzCurrentPosL  = zzCurrentPos;
            zzMarkedPosL   = zzMarkedPos;
            zzBufferL      = zzBuffer;
            zzEndReadL     = zzEndRead;
            if (eof) {
              zzInput = YYEOF;
              break zzForAction;
            }
            else {
              zzInput = Character.codePointAt(zzBufferL, zzCurrentPosL, zzEndReadL);
              zzCurrentPosL += Character.charCount(zzInput);
            }
          }
          int zzNext = zzTransL[ zzRowMapL[zzState] + zzCMap(zzInput) ];
          if (zzNext == -1) break zzForAction;
          zzState = zzNext;

          zzAttributes = zzAttrL[zzState];
          if ( (zzAttributes & 1) == 1 ) {
            zzAction = zzState;
            zzMarkedPosL = zzCurrentPosL;
            if ( (zzAttributes & 8) == 8 ) break zzForAction;
          }

        }
      }

      // store back cached position
      zzMarkedPos = zzMarkedPosL;

      if (zzInput == YYEOF && zzStartRead == zzCurrentPos) {
        zzAtEOF = true;
            switch (zzLexicalState) {
            case inPreamble: {
              output.append("</mrk:preambolo>");
		
		return YYEOF;
            }  // fall though
            case 401: break;
            default:
        return YYEOF;
        }
      }
      else {
        switch (zzAction < 0 ? zzAction : ZZ_ACTION[zzAction]) {
          case 1:
            { output.append(yytext());
            }
          // fall through
          case 15: break;
          case 2:
            { lineNumber++;
	output.append(yytext());
            }
          // fall through
          case 16: break;
          case 3:
            { output.append(yytext()); extendTitle.append(yytext());
            }
          // fall through
          case 17: break;
          case 4:
            { 
            }
          // fall through
          case 18: break;
          case 5:
            { output.append("<mrk:br/>");
            }
          // fall through
          case 19: break;
          case 6:
            { output.append("<mrk:titoloDoc>");
		
		if(getMarkerDocument().isExtendEuTitles()) {
			
			output.append(extendTitle.toString().replaceAll("\\s+"," ").trim() + " ");
		}
            }
          // fall through
          case 20: break;
          case 7:
            { output.append("<mrk:numeroDoc>" + yytext() + "</mrk:numeroDoc>"); extendTitle.append(yytext() + " ");
            }
          // fall through
          case 21: break;
          case 8:
            { extendTitle.append(" "); yybegin(inDate);
            }
          // fall through
          case 22: break;
          case 9:
            { output.append("<mrk:dataDoc>" + yytext() + "</mrk:dataDoc>"); extendTitle.append(yytext());
            }
          // fall through
          case 23: break;
          case 10:
            { extendTitle.append(" "); yybegin(inTitle);
            }
          // fall through
          case 24: break;
          case 11:
            { output.append("</mrk:titoloDoc>\n</mrk:intestazioneDoc>\n<mrk:preambolo>"); yybegin(inPreamble);
            }
          // fall through
          case 25: break;
          case 12:
            { output.append("<mrk:emananteIntestazione>" + yytext() + "</mrk:emananteIntestazione>"); extendTitle.append(yytext() + " ");
            }
          // fall through
          case 26: break;
          case 13:
            { output.append("<mrk:tipoDoc>" + yytext() + "</mrk:tipoDoc>"); extendTitle.append(yytext() + " ");
            }
          // fall through
          case 27: break;
          case 14:
            { if(lineNumber < 2) {
		
		headerFound = true;
		
		output.append("<mrk:intestazioneDoc>\n");
		
		yypushback(yylength());
		yybegin(inDocType);
	
	} else {
	
		output.append(yytext());
	}
            }
          // fall through
          case 28: break;
          default:
            zzScanError(ZZ_NO_MATCH);
        }
      }
    }
  }

  /**
   * Runs the scanner on input files.
   *
   * This is a standalone scanner, it will print any unmatched
   * text to System.out unchanged.
   *
   * @param argv   the command line, contains the filenames to run
   *               the scanner on.
   */
  public static void main(String[] argv) {
    if (argv.length == 0) {
      System.out.println("Usage : java HeaderEurLex [ --encoding <name> ] <inputfile(s)>");
    }
    else {
      int firstFilePos = 0;
      String encodingName = "UTF-8";
      if (argv[0].equals("--encoding")) {
        firstFilePos = 2;
        encodingName = argv[1];
        try {
          // Side-effect: is encodingName valid?
          java.nio.charset.Charset.forName(encodingName);
        } catch (Exception e) {
          System.out.println("Invalid encoding '" + encodingName + "'");
          return;
        }
      }
      for (int i = firstFilePos; i < argv.length; i++) {
        HeaderEurLex scanner = null;
        java.io.FileInputStream stream = null;
        java.io.Reader reader = null;
        try {
          stream = new java.io.FileInputStream(argv[i]);
          reader = new java.io.InputStreamReader(stream, encodingName);
          scanner = new HeaderEurLex(reader);
          while ( !scanner.zzAtEOF ) scanner.yylex();
        }
        catch (java.io.FileNotFoundException e) {
          System.out.println("File not found : \""+argv[i]+"\"");
        }
        catch (java.io.IOException e) {
          System.out.println("IO error scanning file \""+argv[i]+"\"");
          System.out.println(e);
        }
        catch (Exception e) {
          System.out.println("Unexpected exception:");
          e.printStackTrace();
        }
        finally {
          if (reader != null) {
            try {
              reader.close();
            }
            catch (java.io.IOException e) {
              System.out.println("IO error closing file \""+argv[i]+"\"");
              System.out.println(e);
            }
          }
          if (stream != null) {
            try {
              stream.close();
            }
            catch (java.io.IOException e) {
              System.out.println("IO error closing file \""+argv[i]+"\"");
              System.out.println(e);
            }
          }
        }
      }
    }
  }


}
